Imports Microsoft.VisualBasic
Imports System
Imports System.Diagnostics
Imports System.Runtime.InteropServices
Imports System.Text
Imports System.Windows.Forms

Namespace TelerikEditor
	Friend Class Program

		Private Shared requiredString As String

		Friend Class NativeMethods
			<DllImport("user32.dll")> _
			Public Shared Function ShowWindowAsync(ByVal hWnd As IntPtr, ByVal nCmdShow As Integer) As Boolean
			End Function

			<DllImport("user32.dll")> _
			Public Shared Function SetForegroundWindow(ByVal hWnd As IntPtr) As Boolean
			End Function

			<DllImport("user32.dll")> _
			Public Shared Function EnumWindows(ByVal lpEnumFunc As EnumWindowsProcDel, ByVal lParam As Int32) As Boolean
			End Function

			<DllImport("user32.dll")> _
			Public Shared Function GetWindowThreadProcessId(ByVal hWnd As IntPtr, ByRef lpdwProcessId As Int32) As Integer
			End Function

			<DllImport("user32.dll")> _
			Public Shared Function GetWindowText(ByVal hWnd As IntPtr, ByVal lpString As StringBuilder, ByVal nMaxCount As Int32) As Integer
			End Function

			Public Const SW_SHOWNORMAL As Integer = 1
		End Class

		Public Delegate Function EnumWindowsProcDel(ByVal hWnd As IntPtr, ByVal lParam As Int32) As Boolean

		Private Sub New()
		End Sub
		Private Shared Function EnumWindowsProc(ByVal hWnd As IntPtr, ByVal lParam As Int32) As Boolean
			Dim processId As Integer = 0
			NativeMethods.GetWindowThreadProcessId(hWnd, processId)

			Dim caption As StringBuilder = New StringBuilder(1024)
			NativeMethods.GetWindowText(hWnd, caption, 1024)

			' Use IndexOf to make sure our required string is in the title.
			If processId = lParam AndAlso (caption.ToString().IndexOf(requiredString, StringComparison.OrdinalIgnoreCase) <> -1) Then
				' Restore the window.
				NativeMethods.ShowWindowAsync(hWnd, NativeMethods.SW_SHOWNORMAL)
				NativeMethods.SetForegroundWindow(hWnd)
			End If
			Return True
		End Function

		Public Shared Function ProcessExist(ByVal forceTitle As String) As Boolean
			requiredString = forceTitle
			For Each proc As Process In Process.GetProcessesByName(Application.ProductName)
				If proc.Id <> Process.GetCurrentProcess().Id Then
					NativeMethods.EnumWindows(New EnumWindowsProcDel(AddressOf EnumWindowsProc), proc.Id)
					Return True
				End If
			Next proc

			Return False
		End Function


		''' <summary>
		''' The main entry point for the application.
		''' </summary>
		<STAThread> _
		Shared Sub Main(ByVal args As String())
			Dim singleInstance As Boolean = False
			Dim i As Integer = 0
			Do While i < args.Length
				If args(i).Equals("singleinstance", StringComparison.InvariantCultureIgnoreCase) Then
					singleInstance = True
					Exit Do
				End If
				i += 1
			Loop

			If singleInstance Then
				If (Not ProcessExist("Telerik Editor")) Then
					Application.EnableVisualStyles()
					Application.SetCompatibleTextRenderingDefault(False)
					Application.Run(New MainForm(True))
				End If

				Return
			End If

			Application.EnableVisualStyles()
			Application.SetCompatibleTextRenderingDefault(False)
			Application.Run(New MainForm())
		End Sub
	End Class
End Namespace
